#line 1 "C:/PIC/MikroC/ARMstm32/stm32f407/MMB7STM32M4/IRint/IRintNEC/IRint_Code/mikroC PRO for ARM/IRint_main.c"
#line 1 "c:/pic/mikroc/armstm32/stm32f407/mmb7stm32m4/irint/irintnec/irint_code/mikroc pro for arm/irint_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;
typedef enum {_tavTop, _tavMiddle, _tavBottom} TTextAlignVertical;

typedef struct Screen TScreen;

typedef struct {
 unsigned int X_Min;
 unsigned int X_Max;
 unsigned int Y_Min;
 unsigned int Y_Max;
 char Rotate;
} TTPConstants;

typedef struct Button {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 TTextAlignVertical TextAlignVertical;
 const char *FontName;
 unsigned int Font_Color;
 char VerticalText;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char VerticalText;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int ButtonsCount;
 TButton * const code *Buttons;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
};

extern TScreen Screen1;
extern TLabel Label1;
extern TLabel Label2;
extern TLabel Label3;
extern TLabel Label4;
extern TLabel Label5;
extern TLabel Label6;
extern TLabel Label7;
extern TLabel Label8;
extern TButton ButtonAddress;
extern TLabel Label9;
extern TLabel Label10;
extern TButton ButtonCommand;
extern TLabel Label11;
extern TButton ButtonDebug;
extern TLabel Label12;
extern TButton ButtonInverse;
extern TLabel LabelExt;
extern TLabel Label14;
extern TLabel Label15;
extern TButton ButtonRepeats;
extern TButton * const code Screen1_Buttons[5];
extern TLabel * const code Screen1_Labels[15];




void Action_Blue();
void Action_Green();
void Action_Red();




extern char Label1_Caption[];
extern char Label2_Caption[];
extern char Label3_Caption[];
extern char Label4_Caption[];
extern char Label5_Caption[];
extern char Label6_Caption[];
extern char Label7_Caption[];
extern char Label8_Caption[];
extern char ButtonAddress_Caption[];
extern char Label9_Caption[];
extern char Label10_Caption[];
extern char ButtonCommand_Caption[];
extern char Label11_Caption[];
extern char ButtonDebug_Caption[];
extern char Label12_Caption[];
extern char ButtonInverse_Caption[];
extern char LabelExt_Caption[];
extern char Label14_Caption[];
extern char Label15_Caption[];
extern char ButtonRepeats_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawLabel(TLabel *ALabel);
void Check_TP();
void Start_TP();
void Process_TP_Press(unsigned int X, unsigned int Y);
void Process_TP_Up(unsigned int X, unsigned int Y);
void Process_TP_Down(unsigned int X, unsigned int Y);
#line 49 "C:/PIC/MikroC/ARMstm32/stm32f407/MMB7STM32M4/IRint/IRintNEC/IRint_Code/mikroC PRO for ARM/IRint_main.c"
unsigned long input_data;
unsigned long mydebug;
unsigned int counter;
unsigned int ir_add;
unsigned int ir_cmd;
unsigned char gap_flag;
unsigned char repeat_count;
unsigned char repeat_flag;
unsigned char ir_state;
unsigned char bit_count;
unsigned char ir_found;
unsigned char ir_now;
unsigned char cmp1;
unsigned char cmp2;
char text_buffer[20];



void InitTimer2(){
 RCC_APB1ENR.TIM2EN = 1;
 TIM2_CR1.CEN = 0;
 TIM2_PSC = 75;
 TIM2_ARR = 25000;
 NVIC_IntEnable(IVT_INT_TIM2);
 TIM2_DIER.UIE = 1;
 TIM2_CR1.CEN = 1;
}


void Timer2_interrupt() iv IVT_INT_TIM2 {
 TIM2_SR.UIF = 0;
 GPIOF_ODR.B2 = 1;
 gap_flag = 1;
 GPIOC_ODR.B13 = 1;
 GPIOE_ODR.B4 = 0;
 GPIOF_ODR.B1 = 0;
 if(ir_state == 0){
 ir_state = 1;
 }
}


void ExtInt() iv IVT_INT_EXTI15_10 ics ICS_AUTO {
 EXTI_PR.B10 = 1;
 gap_flag = 0;
 GPIOF_ODR.B2 = 0;
 if(EXTI_RTSR.B10){
 GPIOB_ODR.B4 = 0;
 GPIOF_ODR.B7 = 1;
 EXTI_RTSR = 0x00000000;
 EXTI_FTSR = 0x00000400;
 ir_now = 1;
 }
 else{
 GPIOB_ODR.B4 = 1;
 GPIOF_ODR.B7 = 0;
 EXTI_RTSR = 0x00000400;
 EXTI_FTSR = 0x00000000;
 ir_now = 0;
 }

 switch(ir_state){
 case 1:
 ir_state = 2;
 break;
 case 2:
 counter = TIM2_CNT;
 if((counter > 8000) && (counter < 10000)){
 ir_state = 3;
 }
 else{
 ir_state = 0;
 }
 break;
 case 3:
 if(!ir_now){
 counter = TIM2_CNT;
 if((counter > 2000) && (counter < 2500)){
 bit_count = 0;
 input_data = 0;
 GPIOF_ODR.B1 = 1;
 repeat_count++;
 repeat_flag = 1;
 ir_state = 0;
 }
 if((counter > 4000) && (counter < 5000)){
 bit_count = 0;
 input_data = 0;
 ir_state = 4;
 }
 else{
 ir_state = 0;
 }
 break;
 }
 case 4:
 if(!ir_now){


 counter = TIM2_CNT;
 bit_count++;
 input_data >>= 1;

 if(counter > 1200){
 input_data |= 0x80000000UL;
 }
 if (bit_count == 32){
 GPIOE_ODR.B4 = 1;
 mydebug = input_data;
 ir_found = 1;
 ir_add = input_data;
 ir_cmd = (input_data >> 16);

 ir_state = 0;
 }
 }
 break;
 default: ir_state = 0;
 }

 TIM2_CNT = 0;

}

void main() {
 GPIO_Digital_Output(&GPIOB_BASE, _GPIO_PINMASK_4);
 GPIOB_ODR.B4 = 0;
 GPIO_Digital_Input(&GPIOB_BASE, _GPIO_PINMASK_10);
 GPIO_Digital_Output(&GPIOE_BASE, _GPIO_PINMASK_4);
 GPIOE_ODR.B4 = 0;
 GPIO_Digital_Output(&GPIOF_BASE, _GPIO_PINMASK_2);
 GPIOF_ODR.B2 = 0;
 GPIO_Digital_Output(&GPIOF_BASE, _GPIO_PINMASK_7);
 GPIOF_ODR.B7 = 0;
 GPIO_Digital_Output(&GPIOF_BASE, _GPIO_PINMASK_1);
 GPIOF_ODR.B1 = 0;

 SYSCFGEN_bit = 1;
 SYSCFG_EXTICR3 = 0x00000100;
 EXTI_RTSR = 0x00000000;
 EXTI_FTSR = 0x00000400;
 EXTI_IMR |= 0x00000400;
 NVIC_IntEnable(IVT_INT_EXTI15_10);
 InitTimer2();
 gap_flag = 0;
 ir_state = 0;
 repeat_flag = 0;

 Start_TP();

 while (1) {
 Check_TP();
 if(ir_found){
 ir_found=0;
 repeat_count = 0;
 WordToHex(ir_add, text_buffer);
 ButtonAddress.Caption[2] = text_buffer[2];
 ButtonAddress.Caption[3] = text_buffer[3];
 ButtonAddress.Caption[4] = text_buffer[0];
 ButtonAddress.Caption[5] = text_buffer[1];
 WordToHex(ir_cmd, text_buffer);
 ButtonInverse.Caption[2] = text_buffer[0];
 ButtonInverse.Caption[3] = text_buffer[1];
 ButtonCommand.Caption[2] = text_buffer[2];
 ButtonCommand.Caption[3] = text_buffer[3];
 LongWordToHex(mydebug, text_buffer);
 ButtonDebug.Caption[0] = text_buffer[0];
 ButtonDebug.Caption[1] = text_buffer[1];
 ButtonDebug.Caption[2] = text_buffer[2];
 ButtonDebug.Caption[3] = text_buffer[3];
 ButtonDebug.Caption[4] = text_buffer[4];
 ButtonDebug.Caption[5] = text_buffer[5];
 ButtonDebug.Caption[6] = text_buffer[6];
 ButtonDebug.Caption[7] = text_buffer[7];
 ButtonInverse.Gradient_Start_Color = 0xf800;
 cmp1 = ir_cmd >> 8;
 cmp2 = ir_cmd;
 if(cmp1 == ~cmp2){
 ButtonInverse.Gradient_Start_Color = 0x4d81;
 }
 LabelExt.Font_Color = Label8.Font_Color;
 cmp1 = ir_add >> 8;
 cmp2 = ir_add;
 if(cmp1 == ~cmp2){
 LabelExt.Font_Color = 0;
 }
 WordToHex(repeat_count, text_buffer);
 ButtonRepeats.Caption[2] = text_buffer[2];
 ButtonRepeats.Caption[3] = text_buffer[3];
 DrawButton(&ButtonDebug);
 DrawButton(&ButtonAddress);
 DrawButton(&ButtonCommand);
 DrawButton(&ButtonInverse);
 DrawButton(&ButtonRepeats);
 DrawLabel(&LabelExt);
 }
 if(repeat_flag){
 repeat_flag = 0;
 WordToHex(repeat_count, text_buffer);
 ButtonRepeats.Caption[2] = text_buffer[2];
 ButtonRepeats.Caption[3] = text_buffer[3];
 DrawButton(&ButtonRepeats);
 }
 }
}
