#line 1 "C:/PIC/MikroC/ARMstm32/stm32f407/MMB7STM32M4/IRint/IRintRC5/IRint_Code/mikroC PRO for ARM/IRint_driver.c"
#line 1 "c:/pic/mikroc/armstm32/stm32f407/mmb7stm32m4/irint/irintrc5/irint_code/mikroc pro for arm/irint_objects.h"
typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;
typedef enum {_tavTop, _tavMiddle, _tavBottom} TTextAlignVertical;

typedef struct Screen TScreen;

typedef struct {
 unsigned int X_Min;
 unsigned int X_Max;
 unsigned int Y_Min;
 unsigned int Y_Max;
 char Rotate;
} TTPConstants;

typedef struct Button {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char Pen_Width;
 unsigned int Pen_Color;
 char Visible;
 char Active;
 char Transparent;
 char *Caption;
 TTextAlign TextAlign;
 TTextAlignVertical TextAlignVertical;
 const char *FontName;
 unsigned int Font_Color;
 char VerticalText;
 char Gradient;
 char Gradient_Orientation;
 unsigned int Gradient_Start_Color;
 unsigned int Gradient_End_Color;
 unsigned int Color;
 char PressColEnabled;
 unsigned int Press_Color;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TButton;

typedef struct Label {
 TScreen* OwnerScreen;
 char Order;
 unsigned int Left;
 unsigned int Top;
 unsigned int Width;
 unsigned int Height;
 char *Caption;
 const char *FontName;
 unsigned int Font_Color;
 char VerticalText;
 char Visible;
 char Active;
 void (*OnUpPtr)();
 void (*OnDownPtr)();
 void (*OnClickPtr)();
 void (*OnPressPtr)();
} TLabel;

struct Screen {
 unsigned int Color;
 unsigned int Width;
 unsigned int Height;
 unsigned int ObjectsCount;
 unsigned int ButtonsCount;
 TButton * const code *Buttons;
 unsigned int LabelsCount;
 TLabel * const code *Labels;
};

extern TScreen Screen1;
extern TLabel Label1;
extern TLabel Label2;
extern TLabel Label3;
extern TLabel Label4;
extern TLabel Label5;
extern TLabel Label6;
extern TLabel Label7;
extern TLabel Label8;
extern TButton ButtonAddress;
extern TLabel Label9;
extern TLabel Label10;
extern TButton ButtonCommand;
extern TLabel Label11;
extern TButton Button7cmd;
extern TLabel Label12;
extern TLabel Label13;
extern TButton ButtonToggle;
extern TButton ButtonS2;
extern TButton * const code Screen1_Buttons[5];
extern TLabel * const code Screen1_Labels[13];




void Action_Blue();
void Action_Green();
void Action_Red();




extern char Label1_Caption[];
extern char Label2_Caption[];
extern char Label3_Caption[];
extern char Label4_Caption[];
extern char Label5_Caption[];
extern char Label6_Caption[];
extern char Label7_Caption[];
extern char Label8_Caption[];
extern char ButtonAddress_Caption[];
extern char Label9_Caption[];
extern char Label10_Caption[];
extern char ButtonCommand_Caption[];
extern char Label11_Caption[];
extern char Button7cmd_Caption[];
extern char Label12_Caption[];
extern char Label13_Caption[];
extern char ButtonToggle_Caption[];
extern char ButtonS2_Caption[];


void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawLabel(TLabel *ALabel);
void Check_TP();
void Start_TP();
void Process_TP_Press(unsigned int X, unsigned int Y);
void Process_TP_Up(unsigned int X, unsigned int Y);
void Process_TP_Down(unsigned int X, unsigned int Y);
#line 1 "c:/pic/mikroc/armstm32/stm32f407/mmb7stm32m4/irint/irintrc5/irint_code/mikroc pro for arm/irint_resources.h"
const code char Tahoma19x23_Regular[];
const code char Tahoma21x25_Regular[];
const code char Tahoma26x33_Regular[];
const code char Tahoma32x33_Bold[];
const code char Tahoma11x13_Regular[];
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/built_in.h"
#line 7 "C:/PIC/MikroC/ARMstm32/stm32f407/MMB7STM32M4/IRint/IRintRC5/IRint_Code/mikroC PRO for ARM/IRint_driver.c"
unsigned int TFT_DataPort at GPIOE_ODR;
sbit TFT_RST at GPIOF_ODR.B14;
sbit TFT_RS at GPIOF_ODR.B15;
sbit TFT_CS at GPIOF_ODR.B13;
sbit TFT_RD at GPIOF_ODR.B12;
sbit TFT_WR at GPIOF_ODR.B11;
sbit TFT_BLED at GPIOF_ODR.B10;




unsigned int Xcoord, Ycoord;
char PenDown;
void *PressedObject;
int PressedObjectType;
unsigned int caption_length, caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;
TButton *local_button;
TButton *exec_button;
int button_order;
TLabel *local_label;
TLabel *exec_label;
int label_order;


void Write_to_Data_Lines(unsigned char _hi, unsigned char _lo) {
 unsigned int temp;
 temp = GPIOE_ODR;
 temp &= 0x00FF;
 GPIOE_ODR = temp | (_hi << 8);
 temp = GPIOG_ODR;
 temp &= 0xFF00;
 GPIOG_ODR = temp | _lo;
}

void Set_Index(unsigned short index) {
 TFT_RS = 0;
 Write_to_Data_Lines(0, index);
 TFT_WR = 0;
 asm nop;
 TFT_WR = 1;
}

void Write_Command(unsigned short cmd) {
 TFT_RS = 1;
 Write_to_Data_Lines(0, cmd);
 TFT_WR = 0;
 asm nop;
 TFT_WR = 1;
}

void Write_Data(unsigned int _data) {
 TFT_RS = 1;
 Write_to_Data_Lines( ((char *)&_data)[1] ,  ((char *)&_data)[0] );
 TFT_WR = 0;
 asm nop;
 TFT_WR = 1;
}

static void InitializeTouchPanel() {
 TFT_Set_Active(Set_Index, Write_Command, Write_Data);
 TFT_Init_SSD1963_7Inch_800x480(480, 800);

 TFT_Set_DBC_SSD1963(255);

 PenDown = 0;
 PressedObject = 0;
 PressedObjectType = -1;
}



 TScreen* CurrentScreen;

 TScreen Screen1;
 TLabel Label1;
char Label1_Caption[27] = "IR receiver for STM32 MMB7";

 TLabel Label2;
char Label2_Caption[52] = "Scope signals on pins 9, 21 and 22, Gnd on 2 and 26";

 TLabel Label3;
char Label3_Caption[16] = "gap found F2 22";

 TLabel Label4;
char Label4_Caption[10] = "~IR F7 21";

 TLabel Label5;
char Label5_Caption[7] = "Gnd 26";

 TLabel Label6;
char Label6_Caption[6] = "Gnd 2";

 TLabel Label7;
char Label7_Caption[24] = "Good message found E4 9";

 TLabel Label8;
char Label8_Caption[29] = "RC5 Protocol not yet working";

 TButton ButtonAddress;
char ButtonAddress_Caption[6] = "0x\?\?.";

 TLabel Label9;
char Label9_Caption[14] = "5 bit Address";

 TLabel Label10;
char Label10_Caption[14] = "6 bit Command";

 TButton ButtonCommand;
char ButtonCommand_Caption[6] = "0x\?\?.";

 TLabel Label11;
char Label11_Caption[23] = "(7 bit command - S2=0)";

 TButton Button7cmd;
char Button7cmd_Caption[6] = "0x\?\?.";

 TLabel Label12;
char Label12_Caption[7] = "Toggle";

 TLabel Label13;
char Label13_Caption[3] = "S2";

 TButton ButtonToggle;
char ButtonToggle_Caption[2] = "\?";

 TButton ButtonS2;
char ButtonS2_Caption[2] = "\?";

 TButton * const code Screen1_Buttons[5]=
 {
 &ButtonAddress,
 &ButtonCommand,
 &Button7cmd,
 &ButtonToggle,
 &ButtonS2
 };
 TLabel * const code Screen1_Labels[13]=
 {
 &Label1,
 &Label2,
 &Label3,
 &Label4,
 &Label5,
 &Label6,
 &Label7,
 &Label8,
 &Label9,
 &Label10,
 &Label11,
 &Label12,
 &Label13
 };



static void InitializeObjects() {
 Screen1.Color = 0x0000;
 Screen1.Width = 480;
 Screen1.Height = 800;
 Screen1.ButtonsCount = 5;
 Screen1.Buttons = Screen1_Buttons;
 Screen1.LabelsCount = 13;
 Screen1.Labels = Screen1_Labels;
 Screen1.ObjectsCount = 18;


 Label1.OwnerScreen = &Screen1;
 Label1.Order = 0;
 Label1.Left = 33;
 Label1.Top = 21;
 Label1.Width = 351;
 Label1.Height = 36;
 Label1.Visible = 1;
 Label1.Active = 1;
 Label1.Caption = Label1_Caption;
 Label1.FontName = Tahoma26x33_Regular;
 Label1.Font_Color = 0x07E0;
 Label1.VerticalText = 0;
 Label1.OnUpPtr = 0;
 Label1.OnDownPtr = 0;
 Label1.OnClickPtr = 0;
 Label1.OnPressPtr = 0;

 Label2.OwnerScreen = &Screen1;
 Label2.Order = 1;
 Label2.Left = 208;
 Label2.Top = 594;
 Label2.Width = 265;
 Label2.Height = 15;
 Label2.Visible = 1;
 Label2.Active = 1;
 Label2.Caption = Label2_Caption;
 Label2.FontName = Tahoma11x13_Regular;
 Label2.Font_Color = 0xFFE0;
 Label2.VerticalText = 0;
 Label2.OnUpPtr = 0;
 Label2.OnDownPtr = 0;
 Label2.OnClickPtr = 0;
 Label2.OnPressPtr = 0;

 Label3.OwnerScreen = &Screen1;
 Label3.Order = 2;
 Label3.Left = 392;
 Label3.Top = 511;
 Label3.Width = 82;
 Label3.Height = 15;
 Label3.Visible = 1;
 Label3.Active = 1;
 Label3.Caption = Label3_Caption;
 Label3.FontName = Tahoma11x13_Regular;
 Label3.Font_Color = 0xFFFF;
 Label3.VerticalText = 0;
 Label3.OnUpPtr = 0;
 Label3.OnDownPtr = 0;
 Label3.OnClickPtr = 0;
 Label3.OnPressPtr = 0;

 Label4.OwnerScreen = &Screen1;
 Label4.Order = 3;
 Label4.Left = 423;
 Label4.Top = 499;
 Label4.Width = 51;
 Label4.Height = 15;
 Label4.Visible = 1;
 Label4.Active = 1;
 Label4.Caption = Label4_Caption;
 Label4.FontName = Tahoma11x13_Regular;
 Label4.Font_Color = 0xFFFF;
 Label4.VerticalText = 0;
 Label4.OnUpPtr = 0;
 Label4.OnDownPtr = 0;
 Label4.OnClickPtr = 0;
 Label4.OnPressPtr = 0;

 Label5.OwnerScreen = &Screen1;
 Label5.Order = 4;
 Label5.Left = 436;
 Label5.Top = 566;
 Label5.Width = 36;
 Label5.Height = 15;
 Label5.Visible = 1;
 Label5.Active = 1;
 Label5.Caption = Label5_Caption;
 Label5.FontName = Tahoma11x13_Regular;
 Label5.Font_Color = 0xFFFF;
 Label5.VerticalText = 0;
 Label5.OnUpPtr = 0;
 Label5.OnDownPtr = 0;
 Label5.OnClickPtr = 0;
 Label5.OnPressPtr = 0;

 Label6.OwnerScreen = &Screen1;
 Label6.Order = 5;
 Label6.Left = 445;
 Label6.Top = 250;
 Label6.Width = 30;
 Label6.Height = 15;
 Label6.Visible = 1;
 Label6.Active = 1;
 Label6.Caption = Label6_Caption;
 Label6.FontName = Tahoma11x13_Regular;
 Label6.Font_Color = 0xFFFF;
 Label6.VerticalText = 0;
 Label6.OnUpPtr = 0;
 Label6.OnDownPtr = 0;
 Label6.OnClickPtr = 0;
 Label6.OnPressPtr = 0;

 Label7.OwnerScreen = &Screen1;
 Label7.Order = 6;
 Label7.Left = 344;
 Label7.Top = 341;
 Label7.Width = 131;
 Label7.Height = 15;
 Label7.Visible = 1;
 Label7.Active = 1;
 Label7.Caption = Label7_Caption;
 Label7.FontName = Tahoma11x13_Regular;
 Label7.Font_Color = 0xFFFF;
 Label7.VerticalText = 0;
 Label7.OnUpPtr = 0;
 Label7.OnDownPtr = 0;
 Label7.OnClickPtr = 0;
 Label7.OnPressPtr = 0;

 Label8.OwnerScreen = &Screen1;
 Label8.Order = 7;
 Label8.Left = 33;
 Label8.Top = 106;
 Label8.Width = 411;
 Label8.Height = 36;
 Label8.Visible = 1;
 Label8.Active = 1;
 Label8.Caption = Label8_Caption;
 Label8.FontName = Tahoma32x33_Bold;
 Label8.Font_Color = 0x07FF;
 Label8.VerticalText = 0;
 Label8.OnUpPtr = 0;
 Label8.OnDownPtr = 0;
 Label8.OnClickPtr = 0;
 Label8.OnPressPtr = 0;

 ButtonAddress.OwnerScreen = &Screen1;
 ButtonAddress.Order = 8;
 ButtonAddress.Left = 190;
 ButtonAddress.Top = 300;
 ButtonAddress.Width = 80;
 ButtonAddress.Height = 50;
 ButtonAddress.Pen_Width = 1;
 ButtonAddress.Pen_Color = 0x0000;
 ButtonAddress.Visible = 1;
 ButtonAddress.Active = 1;
 ButtonAddress.Transparent = 1;
 ButtonAddress.Caption = ButtonAddress_Caption;
 ButtonAddress.TextAlign = _taCenter;
 ButtonAddress.TextAlignVertical= _tavMiddle;
 ButtonAddress.FontName = Tahoma26x33_Regular;
 ButtonAddress.PressColEnabled = 1;
 ButtonAddress.Font_Color = 0x0000;
 ButtonAddress.VerticalText = 0;
 ButtonAddress.Gradient = 1;
 ButtonAddress.Gradient_Orientation = 0;
 ButtonAddress.Gradient_Start_Color = 0xFFFF;
 ButtonAddress.Gradient_End_Color = 0xC618;
 ButtonAddress.Color = 0xC618;
 ButtonAddress.Press_Color = 0xE71C;
 ButtonAddress.OnUpPtr = 0;
 ButtonAddress.OnDownPtr = 0;
 ButtonAddress.OnClickPtr = 0;
 ButtonAddress.OnPressPtr = 0;

 Label9.OwnerScreen = &Screen1;
 Label9.Order = 9;
 Label9.Left = 33;
 Label9.Top = 310;
 Label9.Width = 125;
 Label9.Height = 28;
 Label9.Visible = 1;
 Label9.Active = 1;
 Label9.Caption = Label9_Caption;
 Label9.FontName = Tahoma21x25_Regular;
 Label9.Font_Color = 0xC618;
 Label9.VerticalText = 0;
 Label9.OnUpPtr = 0;
 Label9.OnDownPtr = 0;
 Label9.OnClickPtr = 0;
 Label9.OnPressPtr = 0;

 Label10.OwnerScreen = &Screen1;
 Label10.Order = 10;
 Label10.Left = 24;
 Label10.Top = 390;
 Label10.Width = 146;
 Label10.Height = 28;
 Label10.Visible = 1;
 Label10.Active = 1;
 Label10.Caption = Label10_Caption;
 Label10.FontName = Tahoma21x25_Regular;
 Label10.Font_Color = 0xC618;
 Label10.VerticalText = 0;
 Label10.OnUpPtr = 0;
 Label10.OnDownPtr = 0;
 Label10.OnClickPtr = 0;
 Label10.OnPressPtr = 0;

 ButtonCommand.OwnerScreen = &Screen1;
 ButtonCommand.Order = 11;
 ButtonCommand.Left = 190;
 ButtonCommand.Top = 382;
 ButtonCommand.Width = 80;
 ButtonCommand.Height = 50;
 ButtonCommand.Pen_Width = 1;
 ButtonCommand.Pen_Color = 0x0000;
 ButtonCommand.Visible = 1;
 ButtonCommand.Active = 1;
 ButtonCommand.Transparent = 1;
 ButtonCommand.Caption = ButtonCommand_Caption;
 ButtonCommand.TextAlign = _taCenter;
 ButtonCommand.TextAlignVertical= _tavMiddle;
 ButtonCommand.FontName = Tahoma26x33_Regular;
 ButtonCommand.PressColEnabled = 1;
 ButtonCommand.Font_Color = 0x0000;
 ButtonCommand.VerticalText = 0;
 ButtonCommand.Gradient = 1;
 ButtonCommand.Gradient_Orientation = 0;
 ButtonCommand.Gradient_Start_Color = 0xFFFF;
 ButtonCommand.Gradient_End_Color = 0xC618;
 ButtonCommand.Color = 0xC618;
 ButtonCommand.Press_Color = 0xE71C;
 ButtonCommand.OnUpPtr = 0;
 ButtonCommand.OnDownPtr = 0;
 ButtonCommand.OnClickPtr = 0;
 ButtonCommand.OnPressPtr = 0;

 Label11.OwnerScreen = &Screen1;
 Label11.Order = 12;
 Label11.Left = 28;
 Label11.Top = 482;
 Label11.Width = 210;
 Label11.Height = 25;
 Label11.Visible = 1;
 Label11.Active = 1;
 Label11.Caption = Label11_Caption;
 Label11.FontName = Tahoma19x23_Regular;
 Label11.Font_Color = 0x4410;
 Label11.VerticalText = 0;
 Label11.OnUpPtr = 0;
 Label11.OnDownPtr = 0;
 Label11.OnClickPtr = 0;
 Label11.OnPressPtr = 0;

 Button7cmd.OwnerScreen = &Screen1;
 Button7cmd.Order = 13;
 Button7cmd.Left = 246;
 Button7cmd.Top = 472;
 Button7cmd.Width = 80;
 Button7cmd.Height = 50;
 Button7cmd.Pen_Width = 1;
 Button7cmd.Pen_Color = 0x0000;
 Button7cmd.Visible = 1;
 Button7cmd.Active = 1;
 Button7cmd.Transparent = 1;
 Button7cmd.Caption = Button7cmd_Caption;
 Button7cmd.TextAlign = _taCenter;
 Button7cmd.TextAlignVertical= _tavMiddle;
 Button7cmd.FontName = Tahoma26x33_Regular;
 Button7cmd.PressColEnabled = 1;
 Button7cmd.Font_Color = 0x0000;
 Button7cmd.VerticalText = 0;
 Button7cmd.Gradient = 1;
 Button7cmd.Gradient_Orientation = 0;
 Button7cmd.Gradient_Start_Color = 0xFFFF;
 Button7cmd.Gradient_End_Color = 0x4410;
 Button7cmd.Color = 0xC618;
 Button7cmd.Press_Color = 0xE71C;
 Button7cmd.OnUpPtr = 0;
 Button7cmd.OnDownPtr = 0;
 Button7cmd.OnClickPtr = 0;
 Button7cmd.OnPressPtr = 0;

 Label12.OwnerScreen = &Screen1;
 Label12.Order = 14;
 Label12.Left = 33;
 Label12.Top = 198;
 Label12.Width = 65;
 Label12.Height = 28;
 Label12.Visible = 1;
 Label12.Active = 1;
 Label12.Caption = Label12_Caption;
 Label12.FontName = Tahoma21x25_Regular;
 Label12.Font_Color = 0xC618;
 Label12.VerticalText = 0;
 Label12.OnUpPtr = 0;
 Label12.OnDownPtr = 0;
 Label12.OnClickPtr = 0;
 Label12.OnPressPtr = 0;

 Label13.OwnerScreen = &Screen1;
 Label13.Order = 15;
 Label13.Left = 214;
 Label13.Top = 204;
 Label13.Width = 24;
 Label13.Height = 28;
 Label13.Visible = 1;
 Label13.Active = 1;
 Label13.Caption = Label13_Caption;
 Label13.FontName = Tahoma21x25_Regular;
 Label13.Font_Color = 0xC618;
 Label13.VerticalText = 0;
 Label13.OnUpPtr = 0;
 Label13.OnDownPtr = 0;
 Label13.OnClickPtr = 0;
 Label13.OnPressPtr = 0;

 ButtonToggle.OwnerScreen = &Screen1;
 ButtonToggle.Order = 16;
 ButtonToggle.Left = 114;
 ButtonToggle.Top = 192;
 ButtonToggle.Width = 80;
 ButtonToggle.Height = 50;
 ButtonToggle.Pen_Width = 1;
 ButtonToggle.Pen_Color = 0x0000;
 ButtonToggle.Visible = 1;
 ButtonToggle.Active = 1;
 ButtonToggle.Transparent = 1;
 ButtonToggle.Caption = ButtonToggle_Caption;
 ButtonToggle.TextAlign = _taCenter;
 ButtonToggle.TextAlignVertical= _tavMiddle;
 ButtonToggle.FontName = Tahoma26x33_Regular;
 ButtonToggle.PressColEnabled = 1;
 ButtonToggle.Font_Color = 0x0000;
 ButtonToggle.VerticalText = 0;
 ButtonToggle.Gradient = 1;
 ButtonToggle.Gradient_Orientation = 0;
 ButtonToggle.Gradient_Start_Color = 0xFFFF;
 ButtonToggle.Gradient_End_Color = 0xC618;
 ButtonToggle.Color = 0xC618;
 ButtonToggle.Press_Color = 0xE71C;
 ButtonToggle.OnUpPtr = 0;
 ButtonToggle.OnDownPtr = 0;
 ButtonToggle.OnClickPtr = 0;
 ButtonToggle.OnPressPtr = 0;

 ButtonS2.OwnerScreen = &Screen1;
 ButtonS2.Order = 17;
 ButtonS2.Left = 271;
 ButtonS2.Top = 195;
 ButtonS2.Width = 80;
 ButtonS2.Height = 50;
 ButtonS2.Pen_Width = 1;
 ButtonS2.Pen_Color = 0x0000;
 ButtonS2.Visible = 1;
 ButtonS2.Active = 1;
 ButtonS2.Transparent = 1;
 ButtonS2.Caption = ButtonS2_Caption;
 ButtonS2.TextAlign = _taCenter;
 ButtonS2.TextAlignVertical= _tavMiddle;
 ButtonS2.FontName = Tahoma26x33_Regular;
 ButtonS2.PressColEnabled = 1;
 ButtonS2.Font_Color = 0x0000;
 ButtonS2.VerticalText = 0;
 ButtonS2.Gradient = 1;
 ButtonS2.Gradient_Orientation = 0;
 ButtonS2.Gradient_Start_Color = 0xFFFF;
 ButtonS2.Gradient_End_Color = 0xC618;
 ButtonS2.Color = 0xC618;
 ButtonS2.Press_Color = 0xE71C;
 ButtonS2.OnUpPtr = 0;
 ButtonS2.OnDownPtr = 0;
 ButtonS2.OnClickPtr = 0;
 ButtonS2.OnPressPtr = 0;
}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) {
 if ( (Left<= X) && (Left+ Width - 1 >= X) &&
 (Top <= Y) && (Top + Height - 1 >= Y) )
 return 1;
 else
 return 0;
}





void DrawButton(TButton *Abutton) {
unsigned int ALeft, ATop;
 if (Abutton->Visible != 0) {
 if (object_pressed == 1) {
 object_pressed = 0;
 TFT_Set_Brush(Abutton->Transparent, Abutton->Press_Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_End_Color, Abutton->Gradient_Start_Color);
 }
 else {
 TFT_Set_Brush(Abutton->Transparent, Abutton->Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_Start_Color, Abutton->Gradient_End_Color);
 }
 TFT_Set_Pen(Abutton->Pen_Color, Abutton->Pen_Width);
 TFT_Rectangle(Abutton->Left, Abutton->Top, Abutton->Left + Abutton->Width - 1, Abutton->Top + Abutton->Height - 1);
 if (Abutton->VerticalText != 0)
 TFT_Set_Font(Abutton->FontName, Abutton->Font_Color, FO_VERTICAL_COLUMN);
 else
 TFT_Set_Font(Abutton->FontName, Abutton->Font_Color, FO_HORIZONTAL);
 TFT_Write_Text_Return_Pos(Abutton->Caption, Abutton->Left, Abutton->Top);
 if (Abutton->TextAlign == _taLeft)
 ALeft = Abutton->Left + 4;
 else if (Abutton->TextAlign == _taCenter)
 ALeft = Abutton->Left + (Abutton->Width - caption_length) / 2;
 else if (Abutton->TextAlign == _taRight)
 ALeft = Abutton->Left + Abutton->Width - caption_length - 4;

 if (Abutton->TextAlignVertical == _tavTop)
 ATop = Abutton->Top + 4;
 else if (Abutton->TextAlignVertical == _tavMiddle)
 ATop = Abutton->Top + ((Abutton->Height - caption_height) / 2);
 else if (Abutton->TextAlignVertical == _tavBottom)
 ATop = Abutton->Top + (Abutton->Height - caption_height - 4);

 TFT_Write_Text(Abutton->Caption, ALeft, ATop);
 }
}

void DrawLabel(TLabel *ALabel) {
 if (ALabel->Visible != 0) {
 if (ALabel->VerticalText != 0)
 TFT_Set_Font(ALabel->FontName, ALabel->Font_Color, FO_VERTICAL_COLUMN);
 else
 TFT_Set_Font(ALabel->FontName, ALabel->Font_Color, FO_HORIZONTAL);
 TFT_Write_Text(ALabel->Caption, ALabel->Left, ALabel->Top);
 }
}

void DrawScreen(TScreen *aScreen) {
 unsigned int order;
 unsigned short button_idx;
 TButton *local_button;
 unsigned short label_idx;
 TLabel *local_label;
 char save_bled, save_bled_direction;

 object_pressed = 0;
 order = 0;
 button_idx = 0;
 label_idx = 0;
 CurrentScreen = aScreen;

 if ((display_width != CurrentScreen->Width) || (display_height != CurrentScreen->Height)) {
 save_bled = TFT_BLED;
 TFT_BLED = 0;
 TFT_Set_Active(Set_Index, Write_Command, Write_Data);
 TFT_Init_SSD1963_7Inch_800x480(CurrentScreen->Width, CurrentScreen->Height);
 STMPE610_SetSize(CurrentScreen->Width, CurrentScreen->Height);
 TFT_Fill_Screen(CurrentScreen->Color);
 TFT_Set_DBC_SSD1963(255);
 display_width = CurrentScreen->Width;
 display_height = CurrentScreen->Height;
 TFT_BLED = save_bled;
 }
 else
 TFT_Fill_Screen(CurrentScreen->Color);


 while (order < CurrentScreen->ObjectsCount) {
 if (button_idx < CurrentScreen->ButtonsCount) {
 local_button =  CurrentScreen->Buttons[button_idx] ;
 if (order == local_button->Order) {
 button_idx++;
 order++;
 DrawButton(local_button);
 }
 }

 if (label_idx < CurrentScreen->LabelsCount) {
 local_label =  CurrentScreen->Labels[label_idx] ;
 if (order == local_label->Order) {
 label_idx++;
 order++;
 DrawLabel(local_label);
 }
 }

 }
}

void Get_Object(unsigned int X, unsigned int Y) {
 button_order = -1;
 label_order = -1;

 for ( _object_count = 0 ; _object_count < CurrentScreen->ButtonsCount ; _object_count++ ) {
 local_button =  CurrentScreen->Buttons[_object_count] ;
 if (local_button->Active != 0) {
 if (IsInsideObject(X, Y, local_button->Left, local_button->Top,
 local_button->Width, local_button->Height) == 1) {
 button_order = local_button->Order;
 exec_button = local_button;
 }
 }
 }


 for ( _object_count = 0 ; _object_count < CurrentScreen->LabelsCount ; _object_count++ ) {
 local_label =  CurrentScreen->Labels[_object_count] ;
 if (local_label->Active != 0) {
 if (IsInsideObject(X, Y, local_label->Left, local_label->Top,
 local_label->Width, local_label->Height) == 1) {
 label_order = local_label->Order;
 exec_label = local_label;
 }
 }
 }

 _object_count = -1;
 if (button_order > _object_count )
 _object_count = button_order;
 if (label_order > _object_count )
 _object_count = label_order;
}


void Process_TP_Press(unsigned int X, unsigned int Y) {
 exec_button = 0;
 exec_label = 0;

 Get_Object(X, Y);

 if (_object_count != -1) {
 if (_object_count == button_order) {
 if (exec_button->Active != 0) {
 if (exec_button->OnPressPtr != 0) {
 exec_button->OnPressPtr();
 return;
 }
 }
 }

 if (_object_count == label_order) {
 if (exec_label->Active != 0) {
 if (exec_label->OnPressPtr != 0) {
 exec_label->OnPressPtr();
 return;
 }
 }
 }

 }
}

void Process_TP_Up(unsigned int X, unsigned int Y) {

 switch (PressedObjectType) {

 case 0: {
 if (PressedObject != 0) {
 exec_button = (TButton*)PressedObject;
 if ((exec_button->PressColEnabled != 0) && (exec_button->OwnerScreen == CurrentScreen)) {
 DrawButton(exec_button);
 }
 break;
 }
 break;
 }
 }

 exec_label = 0;

 Get_Object(X, Y);


 if (_object_count != -1) {

 if (_object_count == button_order) {
 if (exec_button->Active != 0) {
 if (exec_button->OnUpPtr != 0)
 exec_button->OnUpPtr();
 if (PressedObject == (void *)exec_button)
 if (exec_button->OnClickPtr != 0)
 exec_button->OnClickPtr();
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }


 if (_object_count == label_order) {
 if (exec_label->Active != 0) {
 if (exec_label->OnUpPtr != 0)
 exec_label->OnUpPtr();
 if (PressedObject == (void *)exec_label)
 if (exec_label->OnClickPtr != 0)
 exec_label->OnClickPtr();
 PressedObject = 0;
 PressedObjectType = -1;
 return;
 }
 }

 }
 PressedObject = 0;
 PressedObjectType = -1;
}

void Process_TP_Down(unsigned int X, unsigned int Y) {

 object_pressed = 0;
 exec_button = 0;
 exec_label = 0;

 Get_Object(X, Y);

 if (_object_count != -1) {
 if (_object_count == button_order) {
 if (exec_button->Active != 0) {
 if (exec_button->PressColEnabled != 0) {
 object_pressed = 1;
 DrawButton(exec_button);
 }
 PressedObject = (void *)exec_button;
 PressedObjectType = 0;
 if (exec_button->OnDownPtr != 0) {
 exec_button->OnDownPtr();
 return;
 }
 }
 }

 if (_object_count == label_order) {
 if (exec_label->Active != 0) {
 PressedObject = (void *)exec_label;
 PressedObjectType = 2;
 if (exec_label->OnDownPtr != 0) {
 exec_label->OnDownPtr();
 return;
 }
 }
 }

 }
}

void Check_TP() {
 if (STMPE610_PressDetect()) {
 if (STMPE610_GetLastCoordinates(&Xcoord, &Ycoord) == 0) {

 Process_TP_Press(Xcoord, Ycoord);
 if (PenDown == 0) {
 PenDown = 1;
 Process_TP_Down(Xcoord, Ycoord);
 }
 }
 }
 else if (PenDown == 1) {
 PenDown = 0;
 Process_TP_Up(Xcoord, Ycoord);
 }
}

void Init_MCU() {



 GPIO_Digital_Output(&GPIOB_BASE, _GPIO_PINMASK_6);
 GPIO_Digital_Input(&GPIOB_BASE, _GPIO_PINMASK_7);
 GPIOB_ODR.B6 = 1;
 while (GPIOB_IDR.B7 == 0) {
 GPIOB_ODR.B6 = 0;
 Delay_us(10);
 GPIOB_ODR.B6 = 1;
 Delay_us(10);
 }
 I2C1_Init_Advanced(400000, &_GPIO_MODULE_I2C1_PB67);

 TFT_Set_Default_Mode();
 GPIO_Digital_Output(&GPIOG_BASE, 0x00FF);
 GPIO_Digital_Output(&GPIOE_BASE, 0xFF00);
 GPIO_Digital_Output(&GPIOB_BASE, _GPIO_PINMASK_4);
 GPIOB_ODR.B4 = 0;
 TFT_Set_Default_Mode();
 TFT_Set_MM_Plus();
 STMPE610_SetDefaultMode();
}

char STMPE610_Config() {
 STMPE610_SetI2CAddress(STMPE610_I2C_ADDR1);
 if (STMPE610_IsOperational() != 0){
 return STMPE610_IO_NOT_OPERATIONAL;
 }

 STMPE610_Reset();
 STMPE610_Module(STMPE610_MODULE_TS | STMPE610_MODULE_ADC, STMPE610_ENABLE);
 STMPE610_AlternateFunction(STMPE610_GPIO_PIN1, STMPE610_ENABLE);
 STMPE610_SetGPIOPin(STMPE610_GPIO_PIN1, 0);
 STMPE610_SetSize(480,800);
 STMPE610_Module(STMPE610_MODULE_TS | STMPE610_MODULE_ADC, STMPE610_ENABLE);
 STMPE610_EnableInterrupt(STMPE610_IE_TOUCH_DET | STMPE610_IE_FIFO_TH | STMPE610_IE_FIFO_0FLOW, STMPE610_ENABLE);
 STMPE610_ConfigureInterrupt(STMPE610_INT_POLARITY_ACTIVE_HIGH | STMPE610_INT_TYPE_EDGE | STMPE610_INT_ENABLE_ALL);
 STMPE610_SetADC(STMPE610_ADC_CTRL1_SAMPLETIME_44 | STMPE610_ADC_CTRL1_ADC_12BIT | STMPE610_ADC_CTRL1_INT_REFERENCE);
 Delay_10ms(); Delay_10ms();
 STMPE610_SetADCClock(STMPE610_ADC_CTRL2_3250_kHZ);
 STMPE610_AlternateFunction(STMPE610_GPIO_PIN4 | STMPE610_GPIO_PIN5 | STMPE610_GPIO_PIN6 | STMPE610_GPIO_PIN7, STMPE610_DISABLE);
 STMPE610_ConfigureTSC(STMPE610_TSC_CFG_AVE_CTRL_4S, STMPE610_TSC_CFG_TOUCH_DET_DELAY_500uS, STMPE610_TSC_CFG_TOUCH_SETTLING_500uS);
 STMPE610_SetFIFOThreshold(1);
 STMPE610_ResetFIFO();
 STMPE610_TSIDrive(STMPE610_TSC_I_DRIVE_20mA);
 STMPE610_TSControl(STMPE610_TSC_CTRL_TRACK0 | STMPE610_TSC_CTRL_ACQU_XYZ | STMPE610_TSC_CTRL_ENABLE);
 STMPE610_ZDataFraction(STMPE610_FRACP4_WHOLP4);
 STMPE610_SetTouchPressureThreshold(70);
 STMPE610_ClearInterrupts();
 STMPE610_WriteReg(STMPE610_INT_CTRL_REG, 0x01);
 return STMPE610_OK;
}


void Start_TP() {
TTPConstants TPConstsStruct;
 Init_MCU();

 InitializeTouchPanel();
 if (STMPE610_Config() == STMPE610_OK) {
 } else {
 while(1);
 }



 TPConstsStruct.X_Min = 105;
 TPConstsStruct.X_Max = 3925;
 TPConstsStruct.Y_Min = 250;
 TPConstsStruct.Y_Max = 3820;
 TPConstsStruct.Rotate = 3;
 STMPE610_SetCalibrationConsts(&TPConstsStruct);

 InitializeObjects();
 display_width = Screen1.Width;
 display_height = Screen1.Height;
 DrawScreen(&Screen1);
}
