/*
 * Project name:
     pintest.vtft
 * Generated by:
     Visual TFT
 * Date of creation
     05/08/2016
 * Time of creation
     20:54:15
 * Test configuration:
     MCU:             STM32F407ZG
     Dev.Board:       Mikromedia_7_for_STM32F4_ARM
                      http://www.mikroe.com/mikromedia/7/stm32f4/
     Oscillator:      150000000 Hz
     SW:              mikroC PRO for ARM
                      http://www.mikroe.com/mikroc/arm/
 */

#include "pintest_objects.h"

void main() {

  // test one or more outputs with LED or scope
  // use 1 millisecond delay for 500Hz squre wave on scope
  // use 500 millisecond delay for 1Hz LED flash
  // not that not all outputs work by default - some outputs require alternate functions disabled
  // PORTS D and F deliberately left alone as display uses some of these pins

  GPIO_Digital_Output(&GPIOB_BASE, _GPIO_PINMASK_ALL);            // all output that can be
  GPIO_Digital_Output(&GPIOC_BASE, _GPIO_PINMASK_ALL);            // all output that can be
  GPIO_Digital_Output(&GPIOE_BASE, _GPIO_PINMASK_ALL);            // all output that can be
  GPIO_Digital_Output(&GPIOG_BASE, _GPIO_PINMASK_15);             // red LED on G15 output


  Start_TP();

  while (1) {
    Check_TP();

    while(1){                      // note that touchPanel checks will not run due to infinite loop here
      GPIOB_ODR = 0xfee7;          // all high except B8 Piezo, as I do not like the noise  and B3, B4 LEDs as they are too bright
      GPIOC_ODR = 0xffff;          // all high
      GPIOE_ODR = 0xffff;          // all high
      //GPIOG_ODR.B15 = 1 ;          // G15 red LED
      Delay_ms(1);                 // allow time for scope to register 500Hz
      GPIOB_ODR = 0;               // all low
      GPIOC_ODR = 0;               // all low
      GPIOE_ODR = 0;               // all low
      //GPIOG_ODR.B15 = 0;           // G15 red LED
      Delay_ms(1);                 // allow time for scope to register 500Hz
    }

  }
}
